<template>
  <div>
    <!--example json: https://smat-be.herokuapp.com/content?site=twitter&term=trump&limit=20 -->

    <BarChart ref="chart" :chartData="chartData" :options="chartOptions" />
  </div>
</template>

<script>
import BarChart from '@/components/charts/BarChart.vue'

function color (name) {
  const style = getComputedStyle(document.body)
  return style.getPropertyValue(name)
}

export default {
  components: {
    BarChart
  },
  props: {
    resultsData: Array
  },
  computed: {
    chartData () {
      const names = this.resultsData
        .map((tag) => tag.key)
        .map((key) => key.replace(/^https?:\/\//, ''))
        .map((key) => key.replace(/^www\./, ''))
        .map((key) => {
          const max = 30

          if (key.length >= max) {
            return key.slice(0, max - 1) + '…'
          } else {
            return key
          }
        })
      const values = this.resultsData.map((tag) => tag.count)

      return {
        labels: names,
        datasets: [
          {
            backgroundColor: color('--color-primary'),
            data: values
          }
        ]
      }
    },
    chartOptions () {
      return {
        indexAxis: 'y',
        responsive: true,
        maintainAspectRatio: false,
        onResize: this.setHeight,
        plugins: {
          legend: {
            display: false
          },
        },
        scales: {
          x: {
            beginAtZero: true,
            border: {
              dash: [4, 4],
            },
            grid: {
              color: color('--color-dividers')
            }
          },
          y: {
            grid: {
              display: false
            }
          }
        }
      }
    }
  },
  methods: {
    downloadImage () {
      this.$refs.chart.downloadImage()
    },
    setHeight () {
      this.$refs.chart.$el.style.height = '400px'
    }
  }
}
</script>

<style scoped lang="scss"></style>
